import org.rlcommunity.rlglue.codec.RLGlue;
import org.rlcommunity.rlglue.codec.types.Observation_action;
import org.rlcommunity.rlglue.codec.types.Reward_observation_action_terminal;


/**
 * Sample experiment for the recommender task.
 * Presents 50 episodes to the agent and computes the average reward and number of steps.
 *  
 * */
public class Recom_Experiment {

    public void runExperiment() {
        System.out.println("\n\nExperiment starting up!");
        String taskSpec = RLGlue.RL_init();
        System.out.println("RL_init called, the environment sent task spec: " + taskSpec);

        //System.out.println("\n\n----------Sending some sample messages----------");

        /*Talk to the agent and environment a bit...*/
   //     String responseMessage = RLGlue.RL_agent_message("what is your name?");
   //     System.out.println("Agent responded to \"what is your name?\" with: " + responseMessage);

        String responseMessage = RLGlue.RL_env_message("Configuration");
        System.out.println("Environment responded to \"Configuration\" with: " + responseMessage);

        System.out.println("\n\n----------Running Experiment----------");
        int numEpisodes = 50;
        double totalReward = 0;
        double numSteps = 0;
        for (int i = 0; i < numEpisodes; i++) {
        	System.out.print("Episode: "+i);
            int terminal = RLGlue.RL_episode(0);
            int episodeSteps = RLGlue.RL_num_steps();
            double episodeReward = RLGlue.RL_return();
              
            System.out.println(".  Reward: "+episodeReward+".  Steps: "+episodeSteps);
            String agentStats = RLGlue.RL_agent_message("stats");
            System.out.println(agentStats);
            
            numSteps += episodeSteps;
            totalReward += episodeReward;
		}
        numSteps /= numEpisodes;
        totalReward /= numEpisodes;

        System.out.println("\n\n----------Summary----------");
        System.out.println("Number of Episodes: " + numEpisodes + ".  Average reward per episode: " + totalReward+".   Average episode length: "+numSteps);
        RLGlue.RL_cleanup();
    }

    public static void main(String[] args) {
    	Recom_Experiment theExperiment = new Recom_Experiment();
        theExperiment.runExperiment();
    }
}
