import java.io.IOException;

import org.rlcommunity.rlglue.codec.util.AgentLoader;
import org.rlcommunity.rlglue.codec.util.EnvironmentLoader;


public class RunAllRecommender {
	public static void main(String[] args){
		//Create an agentLoader that will start the agent when its run method is called
		AgentLoader theAgentLoader=new AgentLoader(new Recom_Agent());
		//Create an environmentloader that will start the environment when its run method is called
		EnvironmentLoader theEnvironmentLoader=new EnvironmentLoader(new Recom_Environment());
		
		//Create threads so that the agent and environment can run asynchronously 		
		Thread agentThread=new Thread(theAgentLoader);
		Thread environmentThread=new Thread(theEnvironmentLoader);
		
		//Start the threads
		agentThread.start();
		environmentThread.start();
		
		//Run the main method of the Recommender Experiment, using the arguments were were passed
		//This will run the experiment in the main thread.
		Recom_Experiment.main(args);
		System.out.println("RunAllRecommender Complete");
			
		//Quit Java, including stopping the other threads
		System.exit(1);
	}
}
